#include "kolibri.h"
#include "stdlib.h"

char CONSOLE[] = "/sys/lib/console.obj";
extern char KOL_PARAM[256];

void (* _stdcall con_init)(unsigned w_w, unsigned w_h, unsigned s_w, unsigned s_h, const char* t);
void (* _cdecl printf)(const char* format,...);
void (* _stdcall con_exit)(char bCloseWindow);

///===========================================

void kol_main()
{

int i;
char name[256];
kol_struct_import *imp;
kol_struct_import *imp2;

imp = kol_cofflib_load(CONSOLE);
if (imp == NULL)
	kol_exit();

con_init = ( _stdcall  void (*)(unsigned, unsigned, unsigned, unsigned, const char*)) 
		kol_cofflib_procload (imp, "con_init");
if (con_init == NULL)
	kol_exit();

printf = ( _cdecl void (*)(const char*,...))
		kol_cofflib_procload (imp, "con_printf");
if (printf == NULL)
	kol_exit();

con_exit = ( _stdcall void (*)(char))
		kol_cofflib_procload (imp, "con_exit");

if (con_exit == NULL)
	kol_exit();

imp2 = kol_cofflib_load(KOL_PARAM);
if (imp2 == NULL)
	kol_exit();

con_init(-1, -1, -1, -1, "cObj v0.1 by Albom");

printf ("%10s     %s\n", "addr:", "name:");

for ( i = 0;  i < kol_cofflib_procnum (imp2) ;i++ )
	{
	kol_cofflib_procname (imp2, name, i);
	printf ("%10d     %s\n", kol_cofflib_procload (imp2, name), name);
	}

con_exit(0);

}
